package models

import (
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/mongo"
	ct "gogs.mikescher.com/BlackForestBytes/goext/cursortoken"
)

type CrawlerLogFilter struct {
	CrawlerID   *CrawlerID
	ExecutionID *CrawlerExecutionID
	Type        *CrawlerLogType
}

func (f CrawlerLogFilter) FilterQuery() mongo.Pipeline {
	pipeline := mongo.Pipeline{}

	if f.CrawlerID != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"crawlerID": *f.CrawlerID}}})
	}

	if f.ExecutionID != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"crawlerExecutionID": *f.ExecutionID}}})
	}

	if f.Type != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"type": *f.Type}}})
	}

	return pipeline
}

func (f CrawlerLogFilter) Pagination() (string, ct.SortDirection, string, ct.SortDirection) {
	return "creationTime", ct.SortASC, "_id", ct.SortASC
}
